image: registry.gitlab.com/davidbro-in/ciaa-firmware_v3

include:
  - template: SAST.gitlab-ci.yml
  
variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
    SONAR_HOST_URL: https://sonarcloud.io

stages:
  - build
  - test
  - pages
  
tests:
  stage: test
  script:
    - apt update && apt install -y ruby  build-essential python python-pip snapd
    - gem install ceedling
    - pip install gcovr
    - snap install dotnet-sdk --classic && dotnet-sdk.dotnet tool install -g dotnet-reportgenerator-globaltool
    - ceedling test:all
    - ceedling gcov:all utils:gcov
  artifacts:
    paths:
      - build/artifacts/gcov/GcovCoverageSonarQube.xml
      - build/artifacts/gcov/report.xml
    reports:
      junit: build/artifacts/gcov/report.xml
    expire_in: 1 week  
  only: 
    - merge_requests
    - master
    - develop

get-sonar-binaries: 
  stage: .pre
  cache: 
    policy: push
    key: "${CI_COMMIT_SHORT_SHA}"
    paths: 
      - build-wrapper/
      - sonar-scanner/
  script: 
    # Download sonar-scanner
    - curl -sSLo ./sonar-scanner.zip 'https://binaries.sonarsource.com/Distribution/sonar-scanner-cli/sonar-scanner-cli-4.2.0.1873-linux.zip'
    - unzip -o sonar-scanner.zip
    - mv sonar-scanner-4.2.0.1873-linux sonar-scanner
    # Download build-wrapper
    - curl -sSLo ./build-wrapper-linux-x86.zip "${SONAR_HOST_URL}/static/cpp/build-wrapper-linux-x86.zip"
    - unzip -oj build-wrapper-linux-x86.zip -d ./build-wrapper
  only: 
    - merge_requests
    - master
    - develop

build: 
  stage: build
  cache: 
    policy: pull-push
    key: "${CI_COMMIT_SHORT_SHA}"
    paths: 
      - build-wrapper/
      - sonar-scanner/
      - bw-output/
  script: 
    # Run the build inside the build wrapper
    - cp -r /firmware_v3/* .
    - echo "PROGRAM_PATH = ${CI_PROJECT_DIR%/*}" > program.mk
    - echo "PROGRAM_NAME = ${CI_PROJECT_NAME}" >> program.mk
    - build-wrapper/build-wrapper-linux-x86-64 --out-dir bw-output make
  only: 
    - merge_requests
    - master
    - develop
      
sonarcloud-check: 
  stage: .post
  cache: 
    policy: pull
    key: "${CI_COMMIT_SHORT_SHA}"
    paths: 
      - build-wrapper/
      - sonar-scanner/
      - bw-output/
  script: 
    - sonar-scanner/bin/sonar-scanner -Dsonar.host.url="${SONAR_HOST_URL}" -Dsonar.token="${SONAR_TOKEN}" -Dsonar.qualitygate.wait=true -Dsonar.cfamily.build-wrapper-output=bw-output
  dependencies:
    - tests
  only: 
    - merge_requests
    - master
    - develop

pages:
  image: alpine
  stage: pages
  script:
  - apk update && apk add doxygen
  - doxygen Doxyfile
  - mv doxygen/html/ public/
  artifacts:
    paths:
    - public
  only:
    - merge_requests
    - master
    - develop
